2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
6 # SPDX-License-Identifier: GPL-2.0+
10 # if exiting with 0, write to stdout, else write to stderr
12 [ "${ret}" -eq 1 ] && exec 1>&2
14 Usage: MAKEALL [options] [--] [boards-to-build]
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
36 If no boards are specified, then the default is "powerpc".
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
49 - build all Power Architecture boards:
51 MAKEALL --arch powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
66 # Option processing based on util-linux-2.13/getopt-parse.bash
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
75 [ $? != 0 ] && usage 1
77 # Note the quotes around `$TEMP': they are essential!
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
94 opt_a="(\$2 == \"$2\")"
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
121 opt_v="(\$5 == \"$2\")"
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
162 echo "Internal error!" >&2 ; exit 1 ;;
166 GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
171 # echo "Remaining arguments:"
172 # for arg do echo '--> '"\`$arg'" ; done
174 tools/genboardscfg.py || {
175 echo "Failed to generate boards.cfg" >&2
180 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
184 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
186 if [ "$SELECTED" ] ; then
187 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
189 # Make sure some boards from boards.cfg are actually found
190 if [ -z "$SELECTED" ] ; then
191 echo "Error: No boards selected, invalid arguments"
196 #########################################################################
198 # Print statistics when we exit
202 # Determine number of CPU cores if no default was set
203 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
205 if [ "$BUILD_NCPUS" -gt 1 ]
207 JOBS="-j $((BUILD_NCPUS + 1))"
212 if [ "${MAKEALL_LOGDIR}" ] ; then
213 LOG_DIR=${MAKEALL_LOGDIR}
218 : ${BUILD_NBUILDS:=1}
221 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
223 : ${BUILD_DIR:=./build}
224 mkdir -p "${BUILD_DIR}/ERR"
225 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
230 OUTPUT_PREFIX="${BUILD_DIR}"
232 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
233 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234 find "${LOG_DIR}/" -type f -exec rm -f {} +
239 # Keep track of the number of builds and errors
250 # Helper funcs for parsing boards.cfg
256 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
260 targets_by_arch() { targets_by_field 2 "$@" ; }
261 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262 targets_by_soc() { targets_by_field 4 "$@" ; }
264 #########################################################################
266 #########################################################################
268 LIST_5xx="$(targets_by_cpu mpc5xx)"
270 #########################################################################
272 #########################################################################
274 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
276 #########################################################################
278 #########################################################################
280 LIST_512x="$(targets_by_cpu mpc512x)"
282 #########################################################################
284 #########################################################################
286 LIST_8xx="$(targets_by_cpu mpc8xx)"
288 #########################################################################
290 #########################################################################
292 LIST_4xx="$(targets_by_cpu ppc4xx)"
294 #########################################################################
295 ## MPC8260 Systems (includes 8250, 8255 etc.)
296 #########################################################################
298 LIST_8260="$(targets_by_cpu mpc8260)"
300 #########################################################################
301 ## MPC83xx Systems (includes 8349, etc.)
302 #########################################################################
304 LIST_83xx="$(targets_by_cpu mpc83xx)"
306 #########################################################################
307 ## MPC85xx Systems (includes 8540, 8560 etc.)
308 #########################################################################
310 LIST_85xx="$(targets_by_cpu mpc85xx)"
312 #########################################################################
314 #########################################################################
316 LIST_86xx="$(targets_by_cpu mpc86xx)"
318 #########################################################################
320 #########################################################################
341 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
342 # still using "ppc" instead of "powerpc"
347 #########################################################################
349 #########################################################################
351 LIST_SA="$(targets_by_cpu sa1100)"
353 #########################################################################
355 #########################################################################
357 LIST_ARM7="$(targets_by_cpu arm720t)"
359 #########################################################################
361 #########################################################################
363 LIST_ARM9="$(targets_by_cpu arm920t) \
364 $(targets_by_cpu arm926ejs) \
365 $(targets_by_cpu arm946es) \
368 #########################################################################
370 #########################################################################
371 LIST_ARM11="$(targets_by_cpu arm1136) \
372 $(targets_by_cpu arm1176) \
375 #########################################################################
377 #########################################################################
379 LIST_ARMV7="$(targets_by_cpu armv7)"
381 #########################################################################
383 #########################################################################
385 LIST_ARMV8="$(targets_by_cpu armv8)"
387 #########################################################################
389 #########################################################################
391 LIST_at91="$(targets_by_soc at91)"
393 #########################################################################
395 #########################################################################
397 LIST_pxa="$(targets_by_cpu pxa)"
399 #########################################################################
401 #########################################################################
403 LIST_spear="$(targets_by_soc spear)"
405 #########################################################################
407 #########################################################################
409 LIST_arm="$(targets_by_arch arm | \
410 for ARMV8_TARGET in $LIST_ARMV8; \
411 do sed "/$ARMV8_TARGET/d"; \
415 #########################################################################
416 ## MIPS Systems (default = big endian)
417 #########################################################################
419 LIST_mips="$(targets_by_arch mips)"
421 #########################################################################
423 #########################################################################
425 LIST_openrisc="$(targets_by_arch openrisc)"
427 #########################################################################
429 #########################################################################
431 LIST_x86="$(targets_by_arch x86)"
433 #########################################################################
435 #########################################################################
437 LIST_nios2="$(targets_by_arch nios2)"
439 #########################################################################
440 ## MicroBlaze Systems
441 #########################################################################
443 LIST_microblaze="$(targets_by_arch microblaze)"
445 #########################################################################
447 #########################################################################
449 LIST_m68k="$(targets_by_arch m68k)"
450 LIST_coldfire=${LIST_m68k}
452 #########################################################################
454 #########################################################################
456 LIST_avr32="$(targets_by_arch avr32)"
458 #########################################################################
460 #########################################################################
462 LIST_blackfin="$(targets_by_arch blackfin)"
464 #########################################################################
466 #########################################################################
468 LIST_sh2="$(targets_by_cpu sh2)"
469 LIST_sh3="$(targets_by_cpu sh3)"
470 LIST_sh4="$(targets_by_cpu sh4)"
472 LIST_sh="$(targets_by_arch sh)"
474 #########################################################################
476 #########################################################################
478 LIST_sparc="$(targets_by_arch sparc)"
480 #########################################################################
482 #########################################################################
484 LIST_nds32="$(targets_by_arch nds32)"
486 #########################################################################
488 #########################################################################
490 LIST_arc="$(targets_by_arch arc)"
492 #-----------------------------------------------------------------------
494 get_target_location() {
502 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
503 if [ -z "${line}" ] ; then echo "" ; return ; fi
507 CONFIG_NAME="${7%_defconfig}"
509 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
511 if [ $# -gt 5 ]; then
512 if [ "$6" = "-" ] ; then
519 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
520 [ $# -gt 6 ] && [ "$8" != "-" ] && {
527 # Assign board directory to BOARDIR variable
528 if [ "${vendor}" == "-" ] ; then
531 BOARDDIR=${vendor}/${board}
534 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
537 get_target_maintainers() {
538 local name=`echo $1 | cut -d : -f 3`
540 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
541 if [ -z "${line}" ]; then
546 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
547 [ "$mails" == "-" ] && mails=""
554 awk '$7 == "'$target'" { print $2 }' boards.cfg
558 if [ "$PRINT_MAINTS" != 'y' ] ; then
565 local loc=`get_target_location $1`
567 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
569 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
571 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
573 local dir=`echo ${loc} | cut -d ":" -f 2`
574 local cfg=`echo ${loc} | cut -d ":" -f 1`
575 local git_result=`git log --format=%aE board/${dir} \
576 include/configs/${cfg}.h | grep "@"`
577 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
579 local git_result_top=`echo ${git_result} | tr " " "\n" | \
580 sort | uniq -c | sort -nr | head -n 3 | \
581 sed "s/^ \+[0-9]\+ \+//"`
583 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
584 sort -u | tr "\n" " " | sed "s/ $//" ;
586 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
593 # Each finished build will have a file called ${donep}${n},
594 # where n is the index of the build. Each build
595 # we've already noted as finished will have ${skipp}${n}.
596 # The code managing the build process will use this information
597 # to ensure that only BUILD_NBUILDS builds are in flight at once
598 donep="${LOG_DIR}/._done_"
599 skipp="${LOG_DIR}/._skip_"
601 build_target_killed() {
602 echo "Aborted $target build."
603 # Remove the logs for this board since it was aborted
604 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
612 if [ "$ONLY_LIST" == 'y' ] ; then
613 list_target ${target}
617 if [ $BUILD_MANY == 1 ] ; then
618 output_dir="${OUTPUT_PREFIX}/${target}"
619 mkdir -p "${output_dir}"
620 trap build_target_killed TERM
622 output_dir="${OUTPUT_PREFIX}"
625 target_arch=$(get_target_arch ${target})
626 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
627 if [ "${cross_toolchain}" ] ; then
628 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
629 elif [ "${CROSS_COMPILE}" ] ; then
630 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
635 if [ "${output_dir}" != "." ] ; then
636 MAKE="${MAKE} O=${output_dir}"
639 ${MAKE} mrproper >/dev/null
641 echo "Building ${target} board..."
642 ${MAKE} -s ${target}_defconfig >/dev/null
644 ${MAKE} ${JOBS} ${CHECK} all \
645 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
647 # Check for 'make' errors
648 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
652 OBJS=${output_dir}/u-boot
653 if [ -e ${output_dir}/spl/u-boot-spl ]; then
654 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
657 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
659 if [ $BUILD_MANY == 1 ] ; then
664 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
665 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
667 rm ${LOG_DIR}/${target}.ERR
670 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
671 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
672 : $(( ERR_CNT += 1 ))
673 ERR_LIST="${ERR_LIST} $target"
675 : $(( WRN_CNT += 1 ))
676 WRN_LIST="${WRN_LIST} $target"
679 rm ${LOG_DIR}/${target}.ERR
683 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
685 touch "${donep}${build_idx}"
689 search_idx=${OLDEST_IDX}
690 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
693 if [ -e "${donep}${search_idx}" ] ; then
694 : $(( CURRENT_CNT-- ))
695 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
696 : $(( OLDEST_IDX++ ))
698 # Only want to count it once
699 rm -f "${donep}${search_idx}"
700 touch "${skipp}${search_idx}"
701 elif [ -e "${skipp}${search_idx}" ] ; then
702 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
703 : $(( OLDEST_IDX++ ))
705 : $(( search_idx++ ))
706 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
707 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
708 search_idx=${OLDEST_IDX}
719 # If a LIST_xxx var exists, use it. But avoid variable
720 # expansion in the eval when a board name contains certain
721 # characters that the shell interprets.
724 *) list=$(eval echo '${LIST_'$t'}') ;;
726 if [ -n "${list}" ] ; then
727 build_targets ${list}
729 : $((TOTAL_CNT += 1))
730 : $((CURRENT_CNT += 1))
731 rm -f "${donep}${TOTAL_CNT}"
732 rm -f "${skipp}${TOTAL_CNT}"
733 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
735 touch "${donep}${TOTAL_CNT}"
736 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
738 touch "${donep}${TOTAL_CNT}"
740 if [ $BUILD_MANY == 1 ] ; then
741 build_target ${t} ${TOTAL_CNT} &
744 build_target ${t} ${TOTAL_CNT}
750 # We maintain a running count of all the builds we have done.
751 # Each finished build will have a file called ${donep}${n},
752 # where n is the index of the build. Each build
753 # we've already noted as finished will have ${skipp}${n}.
754 # We track the current index via TOTAL_CNT, and the oldest
755 # index. When we exceed the maximum number of parallel builds,
756 # We look from oldest to current for builds that have completed,
757 # and update the current count and oldest index as appropriate.
758 # If we've gone through the entire list, wait a second, and
759 # reprocess the entire list until we find a build that has
761 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
767 #-----------------------------------------------------------------------
774 # Mac OS X is known to have BSD style ps
775 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
776 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
779 # everything else tries the GNU style
780 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
781 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
785 kill $children 2> /dev/null
786 wait $children 2> /dev/null
792 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
794 # Only count boards that completed
795 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
797 rm -f ${donep}* ${skipp}*
799 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
800 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
801 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
802 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
803 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
804 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
805 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
807 # Remove the logs for any board that was interrupted
808 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
811 : $((TOTAL_CNT -= ${SKIP_CNT}))
813 echo "--------------------- SUMMARY ----------------------------"
814 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
815 echo "Boards skipped: ${SKIP_CNT}"
817 echo "Boards compiled: ${TOTAL_CNT}"
818 if [ ${ERR_CNT} -gt 0 ] ; then
819 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
821 if [ ${WRN_CNT} -gt 0 ] ; then
822 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
824 echo "----------------------------------------------------------"
826 if [ $BUILD_MANY == 1 ] ; then
833 #-----------------------------------------------------------------------
835 # Build target groups selected by options, plus any command line args
836 set -- ${SELECTED} "$@"
837 # run PowerPC by default
838 [ $# = 0 ] && set -- powerpc